/*

    Copyright (c) 2018 - 2020 Analog Flavor EURL

    Contact us for support:
        http://www.analogflavor.com

-----------------------------------------------------------------------------
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.

    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.

    * Neither the name of Analog Flavor EURL nor 
      the names of its contributors may be used to endorse or promote products derived from
      this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
-----------------------------------------------------------------------------

*/

#ifndef WienerMpodLvHvSnmpPython_H
#define WienerMpodLvHvSnmpPython_H

#include "WienerMpodLvHvSnmp.h"


class WienerMpodLvHvSnmpPython {

    WienerMpodLvHvSnmp m_crate;

public:
    WienerMpodLvHvSnmpPython();
    virtual ~WienerMpodLvHvSnmpPython();

    WienerMpodLvHvSnmp *getCratePtr() { return &m_crate; }

    /*
    double channelGetConfigMaxCurrent(unsigned slot_index, unsigned channel_index);
    double channelGetConfigMaxSenseVoltage(unsigned slot_index, unsigned channel_index);
    double channelGetConfigMaxTerminalVoltage(unsigned slot_index, unsigned channel_index);
    double channelGetCurrent(unsigned slot_index, unsigned channel_index);
    double channelGetCurrentFallRate(unsigned slot_index, unsigned channel_index);
    double channelGetCurrentRiseRate(unsigned slot_index, unsigned channel_index);
    int channelGetIndex(unsigned slot_index, unsigned channel_index);
    double channelGetMeasurementCurrent(unsigned slot_index, unsigned channel_index);
    double channelGetMeasurementSenseVoltage(unsigned slot_index, unsigned channel_index);
    double channelGetMeasurementTemperature(unsigned slot_index, unsigned channel_index);
    double channelGetMeasurementTerminalVoltage(unsigned slot_index, unsigned channel_index);
    int channelGetStatus(unsigned slot_index, unsigned channel_index);
    std::string channelGetStatusAsString(unsigned slot_index, unsigned channel_index);
    int channelGetSupervisionBehavior(unsigned slot_index, unsigned channel_index);
    double channelGetSupervisionMaxCurrent(unsigned slot_index, unsigned channel_index);
    double channelGetSupervisionMaxPower(unsigned slot_index, unsigned channel_index);
    double channelGetSupervisionMaxTerminalVoltage(unsigned slot_index, unsigned channel_index);
    double channelGetSupervisionMinSenseVoltage(unsigned slot_index, unsigned channel_index);
    int channelGetSwitch(unsigned slot_index, unsigned channel_index);
    int channelGetTripTime(unsigned slot_index, unsigned channel_index);
    int channelGetUserConfig(unsigned slot_index, unsigned channel_index);
    double channelGetVoltage(unsigned slot_index, unsigned channel_index);
    double channelGetVoltageFallRate(unsigned slot_index, unsigned channel_index);
    double channelGetVoltageRiseRate(unsigned slot_index, unsigned channel_index);
    bool channelSetCurrent(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetCurrentFallRate(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetCurrentRiseRate(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetSupervisionBehavior(unsigned slot_index, unsigned channel_index, int value);
    bool channelSetSupervisionMaxCurrent(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetSupervisionMaxTerminalVoltage(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetSupervisionMinSenseVoltage(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetSwitch(unsigned slot_index, unsigned channel_index, int value);
    bool channelSetTripTime(unsigned slot_index, unsigned channel_index, int value);
    bool channelSetUserConfig(unsigned slot_index, unsigned channel_index, int value);
    bool channelSetVoltage(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetVoltageFallRate(unsigned slot_index, unsigned channel_index, double value);
    bool channelSetVoltageRiseRate(unsigned slot_index, unsigned channel_index, double value);
    const double *channelGetMeasurementCurrentVector(unsigned slot_index, unsigned channel_index, unsigned *vector_size);
    const double *channelGetMeasurementSenseVoltageVector(unsigned slot_index, unsigned channel_index, unsigned *vector_size);
    const double *channelGetMeasurementTerminalVoltageVector(unsigned slot_index, unsigned channel_index, unsigned *vector_size);
    const double *channelGetMeasurementTimeVector(unsigned *vector_size);
    int crateGetFanSpeed();
    int crateGetNumberOfChannels();
    int crateGetNumberOfGroups();
    int crateGetNumberOfModules();
    std::vector<size_t> crateGetOccupiedSlots();
    std::string crateGetSerialNumber();
    std::string crateGetSysDescr();
    int crateGetSysMainSwitch();
    int crateGetSysStatus();
    std::string crateGetSysStatusAsString();
    bool crateSetFanSpeed(int value);
    bool crateSetSysHardwareReset(int value);
    bool crateSetSysMainSwitch(int value);
    int groupGetIndex(unsigned index);
    bool groupSetSwitch(unsigned group_index, int value);
    double moduleGetAuxiliaryMeasurementVoltage0(unsigned slot_index);
    double moduleGetAuxiliaryMeasurementVoltage1(unsigned slot_index);
    std::string moduleGetDescription(unsigned slot_index);
    int moduleGetEventChannelStatus(unsigned slot_index);
    int moduleGetEventStatus(unsigned slot_index);
    std::string moduleGetEventStatusAsString(unsigned slot_index);
    double moduleGetHardwareLimitCurrent(unsigned slot_index);
    double moduleGetHardwareLimitVoltage(unsigned slot_index);
    int moduleGetIndex(unsigned slot_index);
    bool moduleGetIsHvModule(unsigned slot_index);
    // in general only the 1st is used
    double moduleGetMeasurementTemperature0(unsigned slot_index);
    double moduleGetMeasurementTemperature1(unsigned slot_index);
    double moduleGetMeasurementTemperature2(unsigned slot_index);
    double moduleGetMeasurementTemperature3(unsigned slot_index);
    int moduleGetNumberOfChannels(unsigned slot_index);
    double moduleGetRampSpeedCurrent(unsigned slot_index);
    double moduleGetRampSpeedVoltage(unsigned slot_index);
    int moduleGetStatus(unsigned slot_index);
    std::string moduleGetStatusAsString(unsigned slot_index);
    bool moduleSetDoClear(unsigned slot_index, int value);
    bool moduleSetRampSpeedCurrent(unsigned slot_index, double value);
    bool moduleSetRampSpeedVoltage(unsigned slot_index, double value);

    */

private:

};


#endif   //    WienerMpodLvHvSnmpPython_H
